#ifndef _ASTERX1_PROCESS_H
#define _ASTERX1_PROCESS_H

#include <EngEphemeris.hpp>
#include "gps_types.h"
#include <queue>

typedef struct{
  gpstk::EngEphemeris ephemeris;
  bool sync;
  std::vector<bool> missing_frames;
}TEphemerisData;

class CAsteRx1Process
{
  private:
    std::vector<TEphemerisData> ephemeris_data;
    std::queue<TGPSNav> gps_nav_data;
    std::queue<TGPSFrames> gps_raw_data;
  protected:
    void generate_gps_nav(gpstk::EngEphemeris &ephemeris,TGPSNav &gps_nav);
  public:
    CAsteRx1Process();
    static unsigned int get_subframe_id(TGPSFrame &frame);
    void add_subframe(TGPSFrame &frame);
    bool is_new_gps_nav_data_available(void);
    void get_gps_nav_data(TGPSNav &gps_nav,TGPSFrames &frames);
    ~CAsteRx1Process();
};

#endif
